/*========== main.cpp ==========*/
// ⃁C[vLqĂ

#include "main.h"

/*===== O[oϐ =====*/

int key[256];    // ׂẴL[̓͏Ԃێ  (̃\[Xt@CŎgp)
PROGRAM program; // vO̊{\  (̃\[Xt@CŎgp)
STATE state;     // vȌԂ\񋓑
IMAGE image;     // 摜nh܂Ƃ߂\      (̃\[Xt@CŎgp)
BGM bgm;         // ynh(BGM)܂Ƃ߂\ (̃\[Xt@CŎgp)
SE se;           // ynh(SE)܂Ƃ߂\  (̃\[Xt@CŎgp)
FONT font;       // tHgnh܂Ƃ߂\  (̃\[Xt@CŎgp)

/*===== ֐̃vg^Cv錾 =====*/

bool process(); // t[s܂Ƃ߂֐

bool loadmain();  // [h֌W̏ (load.cpp)
void titlemain(); // ^Cgʂ̏ (title.cpp)
void mapmain();   // [h}bv̏ (worldmap.cpp)
void standby();   // ҋ@ (standby.cpp)
void gamemain();  // CQ[̏ (game.cpp)

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	ChangeWindowMode(TRUE);
	SetWindowStyleMode(5);
	SetGraphMode(640, 480, 32);
	SetWindowTextA("肠񂷂III");
	SetOutApplicationLogValidFlag(FALSE);
	SetWindowSizeChangeEnableFlag(TRUE);
	// SetDrawMode();
	if (DxLib_Init()) return -1;

	while (process())
	{
		switch (program.state)
		{
		case LOAD:
			if (!loadmain()) return -1;
			break;

		case TITLE:
			titlemain();
			break;

		case MAP:
			mapmain();
			break;

		case STANDBY:
			standby();
			break;

		case GAME:
			gamemain();
			break;
		}
	}
	DxLib_End();
	return 0;
}

void managefps() // sx60fpsɒ
{
	static int start;    // L^Jn
	static int counter;  // o߃t[
	static float fps;    // 擾fps
	int tmp, took, wait;

	if (counter == 0) start = GetNowCount();
	if (counter == 60)
	{
		tmp = GetNowCount();
		fps = 1000.0f / ((tmp - start) / (float)60);
		counter = 0;
		start = tmp;
	}

	counter++;
	took = GetNowCount() - start;
	wait = counter * 1000 / 60 - took;
	if (wait > 0) Sleep(wait);
}

void managekey() // ׂẴL[̓͏Ԏ擾
{
	char buffer[256]; // ꎞIȕϐ
	GetHitKeyStateAll(buffer); // L[̒l

	for (int n = 0; n < 256; n++) // [vŃL[̗vf1`FbN
	{
		if (buffer[n] != 0) key[n] ++; // ΉL[ɒlZ
		if (buffer[n] == 0) key[n] = 0; // ΉL[̒l0ɂ
	}
	return;	// ֐𔲂
}

bool process()
{
	if (ProcessMessage())      return false;
	if (ScreenFlip())          return false;
	if (ClearDrawScreen())     return false;
	if (clsDx())               return false;
	if (key[KEY_INPUT_Z]) return false;
	managefps();
	managekey();

	return true;
}

void gamemain()
{

}
