/*========== worldmap.cpp ==========*/
// [h}bv̏LqĂ

#include "worldmap.h"

void mapmain()
{
	calculation();
	drawmap();
	drawinfo();
	drawplayer();
	selectstage();
}

void initworldmap()
{
	char buf[256];
	sprintf(buf, "res\\mapdata\\worldmap.txt"); // t@C̎擾
	int handle = FileRead_open(buf, FALSE); // t@C̓WJ

	for (int i = 0; i < 15; i++)
	{
		char map_buffer[256] = {0};

		FileRead_gets(map_buffer, sizeof(map_buffer), handle);

		for (int j = 0; j < 200; j++)
		{
			worldmapdata[i][j] = map_buffer[j];
		}
	}
	FileRead_close(handle);

	mapinfo.x = 160;
	mapinfo.y = 64;
	mapinfo.movement = NO;
	
}

void calculation()
{
	static int moved_x;
	static int moved_y;

	/* ݂̃}bv`bv߂ */

	mapinfo.mapchip_x = mapinfo.x / 32;
	mapinfo.mapchip_y = mapinfo.y / 32;

	/* L[͂ɑ΂鏈 */

	if (mapinfo.movement == NO)
	{
		if (key[KEY_INPUT_RIGHT] == 1)
		{
			if (worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x + 1] == 'w' || worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x + 1] == 'N')
			{
				mapinfo.movement = RIGHT;
				moved_x = mapinfo.x + 96;
				moved_y = mapinfo.y + 0;
			}
		}
		else if (key[KEY_INPUT_LEFT] == 1)
		{
			if (worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x - 1] == 'w' || worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x - 1] == 'N')
			{
				mapinfo.movement = LEFT;
				moved_x = mapinfo.x - 96;
				moved_y = mapinfo.y + 0;
			}
		}
		else if (key[KEY_INPUT_UP] == 1)
		{
			if (worldmapdata[mapinfo.mapchip_y - 1][mapinfo.mapchip_x] == 'j' || worldmapdata[mapinfo.mapchip_y - 1][mapinfo.mapchip_x] == 'N')
			{
				mapinfo.movement = UP;
				moved_x = mapinfo.x + 0;
				moved_y = mapinfo.y - 96;
			}
		}
		else if (key[KEY_INPUT_DOWN] == 1)
		{
			if (worldmapdata[mapinfo.mapchip_y + 1][mapinfo.mapchip_x] == 'j' || worldmapdata[mapinfo.mapchip_y + 1][mapinfo.mapchip_x] == 'N')
			{
				mapinfo.movement = DOWN;
				moved_x = mapinfo.x + 0;
				moved_y = mapinfo.y + 96;
			}
		}
	}

	if (mapinfo.movement != NO && mapinfo.x == moved_x && mapinfo.y == moved_y) mapinfo.movement = NO;

	/* ړԂɑΉ */

	switch (mapinfo.movement)
	{
	case NO:
		moved_x = 0;
		moved_y = 0;
		break;

	case RIGHT:
		mapinfo.x += 2;
		break;

	case LEFT:
		mapinfo.x -= 2;
		break;

	case UP:
		mapinfo.y -= 2;
		break;

	case DOWN:
		mapinfo.y += 2;
	}

	

	// printfDx("X : %d  Y : %d  movement %d", mapinfo.x, mapinfo.y, mapinfo.movement);
}

void drawmap()
{
	/* wi̕` */

	for (int y = 0; y < 15; y++)
	{
		for (int x = 0; x < 20; x++)
		{
			DrawGraph(x * 32, y * 32, image.w_ground, TRUE);
		}
	}


	/* }bv`bv̕` */

	for (int y = 0; y < 12; y++)
	{
		for (int x = 0; x < 20; x++)
		{
			drawmap_sub(x, y, worldmapdata[y][x]);
		}
	}
}

void drawmap_sub(int x, int y, char tmp)
{
	if (tmp == '0') DrawGraph(x * 32 - 32, y * 32 -32, image.w_house, TRUE);
	if (tmp >= '1' && tmp <= '9') DrawGraph(x * 32, y * 32, image.w_stage, TRUE);
	if (tmp == '@') DrawGraph(x * 32, y * 32, image.w_start, TRUE);
	if (tmp == 'I') DrawGraph(x * 32, y * 32, image.w_itemhouse, TRUE);
	if (tmp == 'C') DrawGraph(x * 32, y * 32, image.w_challenge, TRUE);
	if (tmp == 'S') DrawGraph(x * 32, y * 32, image.w_special, TRUE);
	if (tmp == 'E') DrawGraph(x * 32, y * 32, image.w_end, TRUE);
	if (tmp == 'w') DrawGraph(x * 32, y * 32, image.w_line, TRUE);
	if (tmp == 'j') DrawGraph(x * 32, y * 32, image.w_line2, TRUE);
	if (tmp == 'B') DrawGraph(x * 32 - 32, y * 32 - 32, image.w_castle, TRUE);
	if (tmp == 'b') DrawGraph(x * 32 - 32, y * 32 - 32, image.w_castle_sub, TRUE);
}

void drawinfo()
{
	/* Xe[W̕\ */

	DrawGraph(0, 480 - 96, image.w_frame, TRUE); // g̕\

	char playerlives[32]; // c@\p
	sprintf(playerlives, "x %d", program.lives); // \c@ݒ肷
	DrawGraph(500, 420, image.marisa[0], TRUE); // ̉摜\
	DrawStringToHandle(550, 420, playerlives, GetColor(255, 255, 255), font.smallf); // c@
	/*
	// printfDx("\n%c\n", worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x]);
	char stagename[32];
	char stagetitle[64];
	if (worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x] == '1')
	{
		sprintf(stagename, "Stage 1");
		sprintf(stagetitle, "n܂̃Xe[W");
	}
	else
	{
		sprintf(stagename, "---");
		sprintf(stagetitle, "---");
	}
	DrawStringToHandle(50, 400, stagename, GetColor(255, 255, 255), font.middlef);
	DrawStringToHandle(50, 450, stagetitle, GetColor(255, 255, 255), font.smallf);*/

	// At@C當[hł悤ɂ

	switch (worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x])
	{
	case '@':
		DrawStringToHandle(50, 400, "[h}bv", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "\L[ňړ ZL[őI", GetColor(255, 255, 255), font.smallf);
		break;

	case '0':
		DrawStringToHandle(50, 400, "p̉", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "Z[u()ł", GetColor(255, 255, 255), font.smallf);
		break;

	case '1':
		DrawStringToHandle(50, 400, "Xe[W 1", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "n܂̏ꏊ", GetColor(255, 255, 255), font.smallf);
		break;

	case '2':
		DrawStringToHandle(50, 400, "Xe[W 2", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "(*'-'*)", GetColor(255, 255, 255), font.smallf);
		break;
		
	case '3':
		DrawStringToHandle(50, 400, "Xe[W 3", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "IỈŁc", GetColor(255, 255, 255), font.smallf);
		break;

	case '4':
		DrawStringToHandle(50, 400, "Xe[W 4", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "bXSC", GetColor(255, 255, 255), font.smallf);
		break;

	case '5':
		DrawStringToHandle(50, 400, "Xe[W 5", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "^nrb`D", GetColor(255, 255, 255), font.smallf);
		break;

	case '6':
		DrawStringToHandle(50, 400, "Xe[W 6", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "Ȃ̊֌W˂", GetColor(255, 255, 255), font.smallf);
		break;

	case '7':
		DrawStringToHandle(50, 400, "Xe[W 7", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "肵ĂĂˁIII", GetColor(255, 255, 255), font.smallf);
		break;

	case '8':
		DrawStringToHandle(50, 400, "Xe[W 8", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "`Aǂ킟`", GetColor(255, 255, 255), font.smallf);
		break;

	case '9':
		DrawStringToHandle(50, 400, "Xe[W 9", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "X}\Al^؂ꂾ", GetColor(255, 255, 255), font.smallf);
		break;

	case 'b':
		DrawStringToHandle(50, 400, "{X", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "`|! 񂱂̂߂!!`", GetColor(255, 255, 255), font.smallf);
		break;

	case 'B':
		DrawStringToHandle(50, 400, "{X", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "{XłAnC", GetColor(255, 255, 255), font.smallf);
		break;

	case 'I':
		DrawStringToHandle(50, 400, "ACenEX", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, " ", GetColor(255, 255, 255), font.smallf);
		break;

	case 'C':
		DrawStringToHandle(50, 400, "`WnEX", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "MȂ!!", GetColor(255, 255, 255), font.smallf);
		break;

	default:
		DrawStringToHandle(50, 400, "ړc", GetColor(255, 255, 255), font.middlef);
		DrawStringToHandle(50, 445, "Xe[WI𒆁c", GetColor(255, 255, 255), font.smallf);
	}
}

void drawplayer()
{
	DrawGraph(mapinfo.x, mapinfo.y, image.marisa[0], TRUE);
}

void selectstage()
{
	if (mapinfo.movement == NO)
	{
		if (worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x] <= '1' && worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x] <= '9')
		{
			char tmp = worldmapdata[mapinfo.mapchip_y][mapinfo.mapchip_x];
			
			program.state = STANDBY;
		}
	}
}